<?php
if (!defined('SMF'))
	die('Hacking attempt...');

function Handler()
{
	global $topic, $user_info, $txt, $context, $smcFunc;
		
	if (isset($_POST['eventid']))
		$_POST['eventid'] = (int)$_POST['eventid'];
	
	if (!isset($_SESSION['old_url']) 
			OR $user_info['is_guest'] 
			OR empty($_POST['eventid']) 
			OR empty($_POST['Button']))
		redirectexit('topic='.$topic.'.0');
	
	checkSession();

	switch ($_POST['Button'])
	{
		// Clicked register OR editing comment, show T&C page
		case $txt['register_mod_registerButtonValue']:
		case $txt['register_mod_payButton']:
		case $txt['register_mod_editComment']:
			confirmTC();
			break;
		// I agree, so lets register
		case $txt['save'] :
		case $txt['register_mod_iAgree'] :
			Register();
			break;
		// clicked unregister, lets do it!
		case $txt['register_mod_unregisterButton']:
			Unregister();
			break;
		// clicked confirm, i guess we confirm!
		case $txt['register_mod_confirmButton']:
			ConfirmEvent();
			break;
		// unconfirm...
		case $txt['register_mod_unconfirmButton']:
			UnconfirmEvent();
			break;
		// admin delete registered users
		case $txt['register_mod_deleteusers']:
			deleteUsers();
			break;
		// admin confirm registered users
		case $txt['register_mod_confirmusers']:
			confirmUsers();
			break;
		// admin PM selected members
		case $txt['register_mod_pmSel']:
			pmSelected();
			break;
		// download s/sheet
		case $txt['register_mod_download']:
			download();
			break;
		// back to topic if invalid button command
		default:
			redirectexit('topic='.$topic.'.0');
			break;
	}	
}

function confirmTC()
{
	global $smcFunc, $context, $user_info, $txt;
	$request = $smcFunc['db_query']('',"
		SELECT hcc_terms_conds, hcc_add_comment, hcc_max_register
			FROM {db_prefix}calendar 
		WHERE id_event = {int:eventid} 
		LIMIT 1"
		,array('eventid' => $_POST['eventid'],)
		);
	$row = $smcFunc['db_fetch_assoc']($request);
		
	$request = $smcFunc['db_query']('',"
		SELECT hcc_comment, hcc_attend
		FROM {db_prefix}hcb_calendar
		WHERE hcc_id_member = {int:memberid} 
			AND hcc_id_event = {int:eventid}
		LIMIT 1",
		array(
			'memberid' => $user_info['id'], 
			'eventid' => $_POST['eventid'],)
	);
	$com = $smcFunc['db_fetch_assoc']($request);

	$context['registermod_add_comment'] = $row['hcc_add_comment'];
	$context['hcc_comment'] = (isset($com['hcc_comment']) ? $com['hcc_comment'] : '');

	$context['hcc_max_register'] = $row['hcc_max_register']; // max allowed to register per member
	$context['hcc_attend'] = (isset($com['hcc_attend']) ? ($com['hcc_attend'] > $row['hcc_max_register'] ? $row['hcc_max_register'] : $com['hcc_attend']) : 1); // qty registered by this registrant

	$context['hcc_terms_conds'] = parse_bbc($row['hcc_terms_conds']);
	$context['registermod_edit_comment'] = $_POST['Button'] == $txt['register_mod_editComment'] ? 1 : 0; // true if editing a comment
	
	$smcFunc['db_free_result']($request);		
	if (!empty($context['hcc_terms_conds']) OR !empty($row['hcc_add_comment']) OR ($context['hcc_max_register'] > 1))
		loadTemplate('TermsAndConditions');
	else
		Register(); // register for event - no T&Cs, comments or attendee count needed!
}

function Register()
{
	global $user_info, $smcFunc, $topic, $txt;

	// Check if already registered
	$request = $smcFunc['db_query']('',"
		SELECT hcc_id_member
		FROM {db_prefix}hcb_calendar
		WHERE hcc_id_member = {int:memberid} 
			AND hcc_id_event = {int:eventid}
		LIMIT 1",
		array(
			'memberid' => $user_info['id'], 
			'eventid' => $_POST['eventid'],)
	);

	if ($smcFunc['db_num_rows']($request) != 0) // if entry alreasdy exists then update it
		$smcFunc['db_query']('',"
			UPDATE {db_prefix}hcb_calendar
				SET 
					hcc_reg_date = {int:reg_date}, 
					hcc_comment = {string:comment},
					hcc_attend = {int:attend}
			WHERE hcc_id_member = {int:memberid} 
				AND hcc_id_event = {int:eventid}
			LIMIT 1",
			array(
				'memberid' => $user_info['id'], 
				'eventid' => $_POST['eventid'],
				'reg_date' => time(),
				'comment' => (!empty($_POST['comment']) ? $smcFunc['htmlspecialchars'](strip_tags(trim($_POST['comment'])), ENT_QUOTES) : ''),
				'attend' => (!empty($_POST['attend']) ? (int)$_POST['attend'] : 1),
			)
		);
	else
		// not already registered, so add new entry
		$smcFunc['db_insert']('',"{db_prefix}hcb_calendar",
			array('hcc_id_member' => 'int', 'hcc_id_event' => 'int', 'hcc_reg_date' => 'int', 'hcc_comment'=> 'string', 'hcc_attend' => 'int'),
			array($user_info['id'], $_POST['eventid'], time(), (!empty($_POST['comment']) ? $smcFunc['htmlspecialchars'](strip_tags(trim($_POST['comment'])), ENT_QUOTES) : ''),(!empty($_POST['attend']) ? (int)$_POST['attend'] : 1),),
			array()
			);

	// mod 9/12 to re-direct to a subscription payment if the event requires a reg payment to be made
	$request = $smcFunc['db_query']('',"
		SELECT hcc_reg_sub_ids FROM {db_prefix}calendar 
		WHERE id_event = {int:eventid} 
		LIMIT 1"
		,array('eventid' => $_POST['eventid'],)
		);
	$row = $smcFunc['db_fetch_assoc']($request);

	if (empty($row['hcc_reg_sub_ids']) OR $_POST['editcom']) // not a payreg event OR just editing a comment!
		redirectexit('topic='.$topic.'.0');
	else
	{
		$request = $smcFunc['db_query']('',"
			SELECT status
			FROM {db_prefix}log_subscribed 
				WHERE id_member = {int:memberid}
				AND status = {string:status}
				AND id_subscribe IN({raw:subids})
			LIMIT 1",
			array (	'status' => '1',
					'subids' => $row['hcc_reg_sub_ids'],
					'memberid' => $user_info['id'],
				)
			);
		if ($smcFunc['db_num_rows']($request) != 0) // if reg payment has already been made then
			redirectexit('topic='.$topic.'.0'); // .... back to topic
		else 
			redirectexit('action=profile;area=subscriptions;event=' . $row['hcc_reg_sub_ids']); // redirect to payment system
	}

}

function Unregister()
{
	global $user_info, $topic, $txt, $smcFunc;
	
	$smcFunc['db_query']('',"
		DELETE FROM {db_prefix}hcb_calendar 
		WHERE hcc_id_member = {int:memberid} 
			AND hcc_id_event = {int:eventid}",
		array(
			'memberid' => $user_info['id'], 
			'eventid' => $_POST['eventid'],)
	);
	redirectexit('topic='.$topic.'.0');
}

function ConfirmEvent()
{
	global $user_info, $topic, $txt, $smcFunc;

	// Check if registered!
	$request = $smcFunc['db_query']('',"
		SELECT hcc_id_member
		FROM {db_prefix}hcb_calendar
		WHERE hcc_id_member = {int:memberid} 
			AND hcc_id_event = {int:eventid}
		LIMIT 1",
		array(
			'memberid' => $user_info['id'], 
			'eventid' => $_POST['eventid'],)
	);

	if ($smcFunc['db_num_rows']($request) == 0)
		fatal_error($txt['register_mod_haventRegistered'], false);
	
	// still here, lets confirm
	$smcFunc['db_query']('',"
		UPDATE {db_prefix}hcb_calendar 
		SET hcc_date_confirmed={int:time} 
		WHERE hcc_id_member = {int:memberid} 
			AND hcc_id_event = {int:eventid}",
		array(
			'memberid' => $user_info['id'], 
			'eventid' => $_POST['eventid'],
			'time' => time(),
		)
	);
	redirectexit('topic='.$topic.'.0');
}

function UnconfirmEvent()
{
	global $user_info, $topic, $txt, $smcFunc;

	$request = $smcFunc['db_query']('',"
		SELECT hcc_id_member
		FROM {db_prefix}hcb_calendar
		WHERE hcc_id_member = {int:memberid} 
			AND hcc_id_event = {int:eventid}
		LIMIT 1",
		array(
			'memberid' => $user_info['id'], 
			'eventid' => $_POST['eventid'],)
	);

	if ($smcFunc['db_num_rows']($request) == 0)
	{
		$smcFunc['db_free_result']($request);
		fatal_error($txt['register_mod_haventRegistered'], false);
	}
	
	// still here, lets unconfirm
	$smcFunc['db_query']('',"
		UPDATE {db_prefix}hcb_calendar 
		SET hcc_date_confirmed = {int:time} 
		WHERE hcc_id_member = {int:memberid} 
			AND hcc_id_event = {int:eventid}",
		array(
			'memberid' => $user_info['id'], 
			'eventid' => $_POST['eventid'],
			'time' => 0,
		)
	);
	redirectexit('topic='.$topic.'.0');
}

function confirmUsers()
{
	global $user_info, $topic, $txt, $smcFunc;

	if (!empty($_POST['delete']))
	{
		if (!is_array($_POST['delete']))
			$_POST['delete'] = array($_POST['delete']);

		// only confirm those that are registered and NOT already confirmed
		$request = $smcFunc['db_query']('',"
			SELECT hcc_id_member
			FROM {db_prefix}hcb_calendar
				WHERE FIND_IN_SET(hcc_id_member, {string:users}) 
				AND hcc_id_event = {int:eventid}
				AND hcc_date_confirmed = ''",
			array(
				'users' => implode(',',$_POST['delete']),
				'eventid' => $_POST['eventid'],
				)
		);

		while ($row = $smcFunc['db_fetch_assoc']($request))
			$users[]= $row['hcc_id_member'];
		$smcFunc['db_free_result']($request);

		// ignore request if no-one to confirm
		if (!empty($users))
		{
			// still here, lets confirm them all
			$smcFunc['db_query']('',"
				UPDATE {db_prefix}hcb_calendar 
				SET hcc_date_confirmed={int:time} 
					WHERE FIND_IN_SET(hcc_id_member, {string:users}) 
						AND hcc_id_event={int:eventid}",
				array(
					'users' => implode(',',$users),
					'eventid' => $_POST['eventid'],
					'time' => time(),
				)
			);
		}
	}
	redirectexit('topic='.$topic.'.0');

}

function deleteUsers()
{
	global $user_info, $topic, $txt, $smcFunc;
	
	if (!empty($_POST['delete']))
	{
		if (!is_array($_POST['delete']))
			$_POST['delete'] = array($_POST['delete']);
		$smcFunc['db_query']('',"
			DELETE FROM {db_prefix}hcb_calendar 
			WHERE FIND_IN_SET(hcc_id_member, {string:users}) 
				AND hcc_id_event={int:eventid}",
			array(
				'users' => implode(',',$_POST['delete']),
				'eventid' => $_POST['eventid'],
			)
		);
	}
	redirectexit('topic='.$topic.'.0');
}

function pmSelected()
{
	global $topic;
	if (!empty($_POST['delete']))
	{
		if (!is_array($_POST['delete']))
			$_POST['delete'] = array($_POST['delete']);
		redirectexit('action=pm;sa=send;u='. implode(',',$_POST['delete']));
	}
	else 
		redirectexit('topic='.$topic.'.0');
}

function download()
{
	global $topic, $smcFunc, $txt;

	// get event details first into $event
	$request = $smcFunc['db_query']('', '
		SELECT cal.start_date, cal.end_date, cal.title, mem.real_name, cal.hcc_max_attendants, cal.hcc_confirm, cal.hcc_days_closed, cal.hcc_terms_conds, cal.hcc_sub_ids, cal.hcc_reg_sub_ids, cal.hcc_add_comment, cal.hcc_max_register
		FROM {db_prefix}calendar AS cal
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = cal.id_member)
		WHERE cal.id_event = {int:eventid}
		ORDER BY start_date
		LIMIT 1',
		array('eventid' => (int)$_POST['eventid'],)
	);
	
	if ($event = $smcFunc['db_fetch_assoc']($request))
	{
		global $csv;
		$csv = '';
		// Prepare the dates for being formatted.
		$start_date = sscanf($event['start_date'], '%04d-%02d-%02d');
		$start_time = mktime(12, 0, 0, $start_date[1], $start_date[2], $start_date[0]);
		$start_date = date("j F Y", $start_time);
		$end_date = sscanf($event['end_date'], '%04d-%02d-%02d');
		$end_date = mktime(12, 0, 0, $end_date[1], $end_date[2], $end_date[0]);
		$end_date = date("j F Y",$end_date);
		
		// event reg type Reg, RegPay, RegPayConf, RegConfPay, RegPayConfPay
		if (empty($event['hcc_groups']) OR ($event['hcc_max_registerants'] == 0)) // is anyone allowed to register?
			$evType = ''; // no reg required
		else
		{
			$evType = 'Reg'; // reg required for all types
			if (!empty($event['hcc_reg_sub_ids']))
				$evType .= 'Pay'; // reg pay needed
			if (!empty($event['hcc_confirm']))
			{
				$evType .= 'Conf';
				if (!empty($event['hcc_sub_ids']))
					$evType .= 'Pay'; // reg pay needed
			}
		}

		// get registrants
		$evrequest = $smcFunc['db_query']('','
			SELECT reg.hcc_reg_date, reg.hcc_date_confirmed, reg.hcc_id_member, reg.hcc_comment, reg.hcc_attend, mem.real_name
				' . ((!empty($event['hcc_sub_ids']) OR !empty($event['hcc_reg_sub_ids'])) ? ', s.payments_pending, s.start_time, s.id_subscribe, subs.name' : '') . '
			FROM {db_prefix}hcb_calendar AS reg
				LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = reg.hcc_id_member)
				' . ((!empty($event['hcc_sub_ids']) OR !empty($event['hcc_reg_sub_ids'])) ? '
				LEFT JOIN {db_prefix}log_subscribed AS s ON (s.id_member = reg.hcc_id_member
					AND s.status= {string:status}
					AND s.id_subscribe IN({raw:subids}))
				LEFT JOIN {db_prefix}subscriptions AS subs ON (s.id_subscribe = subs.id_subscribe)
				' : '') . '
				WHERE reg.hcc_id_event = {int:eventid}
			ORDER BY reg.hcc_date_confirmed DESC, reg.hcc_reg_date DESC',
			array (	'status' => '1',
					'subids' => $event['hcc_sub_ids'] . ((!empty($event['hcc_sub_ids']) AND !empty($event['hcc_reg_sub_ids'])) ? ', ' : '') . $event['hcc_reg_sub_ids'],
					'eventid' => $_POST['eventid'],
			)
		);
		// go through each registration and add reg details to context array
		// could have multiple rows for each member if they have paid for reg AND conf
		$registration = array();
		while ($evrow = $smcFunc['db_fetch_assoc']($evrequest))
		{
			if (empty($event['hcc_reg_sub_ids']) OR isset($evrow['payments_pending'])) // don't add entry if a payreg event and not paid yet!
			{
				$registration[$evrow['hcc_id_member']]['comment'] = $evrow['hcc_comment'];
				$registration[$evrow['hcc_id_member']]['attend'] = $evrow['hcc_attend'];
				$registration[$evrow['hcc_id_member']]['real_name'] = $evrow['real_name'];
				$registration[$evrow['hcc_id_member']]['id_member'] = $evrow['hcc_id_member'];
				if (empty($registration[$evrow['hcc_id_member']]['date_reg']))
					$registration[$evrow['hcc_id_member']]['date_reg'] = $evrow['hcc_reg_date'];
				if (empty($registration[$evrow['hcc_id_member']]['date_conf']))
					$registration[$evrow['hcc_id_member']]['date_conf'] = $evrow['hcc_date_confirmed'];
				// find members who have paid reg fee 
				if (!empty($event['hcc_reg_sub_ids']) AND in_array($evrow['id_subscribe'], explode(',', $event['hcc_reg_sub_ids'])) AND isset($evrow['payments_pending']))
				{
					$registration[$evrow['hcc_id_member']]['date_reg'] = $evrow['start_time'];	// paid or awaiting payment, so use sub payment date instead
					$registration[$evrow['hcc_id_member']]['reg_paid_status'] = $evrow['payments_pending'];	// payment status (0= paid, nz = awaiting payment)
					$registration[$evrow['hcc_id_member']]['reg_paid_name'] = $evrow['name'];
				}
				// find members who have paid conf fee and confirm them
				// only if the event requires confirmation!!
				if (!empty($event['hcc_sub_ids']) AND $event['hcc_confirm'] AND in_array($evrow['id_subscribe'], explode(',',$event['hcc_sub_ids'])) AND isset($evrow['payments_pending']))
				{
					$registration[$evrow['hcc_id_member']]['date_conf'] = $evrow['start_time'];	// paid or awaiting payment, so use sub payment date instead
					$registration[$evrow['hcc_id_member']]['conf_paid_status'] = $evrow['payments_pending'];	// payment status (0= paid, nz = awaiting payment)
					$registration[$evrow['hcc_id_member']]['conf_paid_name'] = $evrow['name'];
				}
			}
		}
		$smcFunc['db_free_result']($evrequest);
		$event['registration']= $registration;
	
		// process array to remove any false confirmations when a required reg payment hasn't been made on a confirmable event OR it's a non-confirm event
		// make ID lists and set vars
		$RegCount = $ConfCount = 0;
		foreach ($event['registration'] as $key=>$reg)
		{
			$RegCount = $RegCount + ($event['hcc_max_register']>1 ? $reg['attend'] : 1); // add real number of attendees

			if (!($event['hcc_confirm']) OR (!empty($event['hcc_reg_sub_ids']) AND !isset($reg['reg_paid_status'])))
			{
				$event['registration'][$key]['date_conf'] = '';
				unset($event['registration'][$key]['conf_paid_status']);
				unset($event['registration'][$key]['conf_paid_name']);
			}

			if (!empty($event['registration'][$key]['date_conf'])) 
				$ConfCount = $ConfCount + ($event['hcc_max_register']>1 ? $reg['attend'] : 1); // add real number of attendees
		}

		$default_len = 6;
		// html event details first
		$csv = '';
		csv_line(array($event['title'],$start_date . ($start_date != $end_date ? ' - ' . $end_date : '')));
		csv_line(
			array(' ',
				$txt['register_mod_daysClosed'] . date('d-M-Y', $start_time - ($event['hcc_days_closed'] * 86400)),
				$txt['register_mod_maxAttendants'] . $event['hcc_max_attendants'],
				($RegCount-$ConfCount) . ' ' . $txt['register_mod_registered'] . ($event['hcc_confirm'] ? ', ' . $ConfCount . ' '. $txt['register_mod_confirmed']  : ''),
				)
			);

		// now output list of registrants
		if ($RegCount > 0)
		{
			foreach($event['registration'] as $reg)
			{			
				csv_line(array(' ',
					$reg['real_name'], 
					($event['hcc_max_register']>1 ? $reg['attend'] : ''),
					($reg['date_conf'] 	? $txt['register_mod_confirmed'] . (isset($reg['conf_paid_status']) ? $txt['register_mod_paid'] : ' ') 
										: $txt['register_mod_registered'] . (isset($reg['reg_paid_status']) ? $txt['register_mod_paid'] : ' ')
					),
					date(" j M Y",($reg['date_conf'] ? $reg['date_conf'] : $reg['date_reg'])),
					((!empty($event['hcc_sub_ids']) OR !empty($event['hcc_reg_sub_ids'])) ? 
						(isset($reg['reg_paid_status']) ? $reg['reg_paid_name'] . (isset($reg['conf_paid_status']) ? "\n" : ' ' ) : ' ') . (isset($reg['conf_paid_status']) ? $reg['conf_paid_name'] : ' ')
					: ''),
					($event['hcc_add_comment'] ? $reg['comment'] : ''),
				));	
			}
		}
		//output to CSV file
		header("Content-type: application/vnd.ms-excel");
		header("Content-disposition: attachment; filename=" . date("Y-m-d") ."_event.csv; size=".strlen($csv));
		echo $csv;
	}
	exit;
}

	function csv_line($array = array())
	{
		global $default_len, $csv;
		foreach($array as $k=>$a)
			if ($array[$k]=='')
				unset($array[$k]); // remove empty cells
		while (count($array) < $default_len)
			$array[] = ' '; // pad to correct csv line length
		foreach($array as $k=>$a)
		{
			if (empty($array[$k]))
				$array[$k] = ' '; // make sure no empty entries
			str_replace('"','""',$array[$k]); // escape double quotes 
		}
		$csv .= '"' . implode('","', $array) . "\"\n"; // off it goes!
	}			

?>